stacksize('max');

args = sciargs();
disp (args, 'sciargs = ');
if size(args) < 7 then
    imXPixel = strtod(args(4));
    projPath = args(5);
    dataPath = args(6);
else
    imXPixel = strtod(args(5));
    projPath = args(6);
    dataPath = args(7);
end

N = imXPixel;
n = 5;

//load data
xAxis = ones(N);
y = ones(N);

fd = mopen(dataPath, 'r');
for i = 1:N
    [m, xAxis(i),y(i)] = mfscanf(fd, '%f\t%f');
end
file('close', fd);

clf(1); scf(1);
plot(y);

y = y - sum(y) ./ N; //correct mean 
u=(rand(y)-0.5) ./ 10000 ;
u(1)=1.4;            // impulse response

//2nd order predictor
for i = n:(N-1)
    F(i-n+1, 1)=  -y(i);
    F(i-n+1, 2)=  -y(i-1);
end
//disp(F, 'F: ');

// least square model
K=inv(F' * F)* F' * y(n+1:N);
//disp(K);

// use K and show impuls response
z=poly(0,'z');
gain=50;//K(5)/100;
H=syslin('d',gain,  z^2+K(1)*z+K(2));
Hss=tf2ss(H);
y2=dsimul(Hss,u');// dsimu is much better than flir
//plot(y2, '-r');

// change sample freq
T=xAxis(2)-xAxis(1);
//disp(T);
a=-log(K(2))/(2*T);
b=acos (-K(1)/2/sqrt(K(2)))/T;

T_disp = T;
T=1/156250;
//T=T/100;

NewK1_disp=-2*exp(-a*T_disp)*cos(b*T_disp);
NewK2_disp=exp(-a*2*T_disp);
NewK1=-2*exp(-a*T)*cos(b*T);
NewK2=exp(-a*2*T);
//disp(NewK1, NewK2);

// cos * e^-t
dcgain_disp=(1-exp(-a*T_disp)*cos(b*T_disp))/(1-2*exp(-a*T_disp)*cos(b*T_disp)+exp(-2*a*T_disp));
a1_disp = 1 / dcgain_disp;
a2_disp = -exp(-a*T_disp)*cos(b*T_disp) / dcgain_disp;
a3_disp = 0 / dcgain_disp;
dcgain=(1-exp(-a*T)*cos(b*T))/(1-2*exp(-a*T)*cos(b*T)+exp(-2*a*T));
a1 = 1 / dcgain;
a2 = -exp(-a*T)*cos(b*T) / dcgain;
a3 = 0 / dcgain;

H1_disp=syslin('d',a1_disp*z*z + a2_disp*z +a3_disp,  z^2+NewK1_disp*z+NewK2_disp);
H1=syslin('d',a1*z*z + a2*z +a3,  z^2+NewK1*z+NewK2);

// now filter data
HINV_disp=inv(H1_disp);
HINV=inv(H1);

b2=b*4.7;  // uv disasterHINV
HINVlp_disp=HINV_disp * 1/(1-exp(-b2*T_disp)/z) * (1-exp(-b2*T_disp));
HINVlpss_disp=tf2ss(HINVlp_disp);
y3_disp=dsimul(HINVlpss_disp,y');
//scf(1);
//plot(y3_disp, '-g');
//clf(2); scf(2);
//bode([H; H1_disp; HINV_disp; HINVlp_disp], 0.0001, 0.5, 0.01);

// save found filtered function for Lazarus
u = file('open', projPath+'\FunctPoints_3.txt', 'unknown');
for i = 1:N
    fprintf(u, '%f', y3_disp(i));
end
file('close', u);


HINVlp=HINV * 1/(1-exp(-b2*T)/z) * (1-exp(-b2*T));
HINVlpss=tf2ss(HINVlp);
y3=dsimul(HINVlpss,y');
//scf(1);
//plot(y3, '-g');
//clf(2); scf(2);
//bode([H; H1; HINV; HINVlp], 0.0001, 0.5, 0.01);

//save coeff
zaehler=coeff(HINVlp(1,1).num);
nenner=coeff(HINVlp(1,1).den);
//zaehler=coeff(HINV(1,1).num);
//nenner=coeff(HINV(1,1).den);
shift=2**31;

a(1)=zaehler(1) * shift;
a(2)=zaehler(2) * shift /2 ;
a(3)=zaehler(3) * shift;
a(4)=-nenner(2)/2 * shift;
a(5)=-nenner(1)   * shift;

a=a ./ nenner(3); // normal form
//disp(a);

//unix('del C:\Users\Daniela\Projekte\Present\120209\a1.txt');
//write('C:\Users\Daniela\Projekte\Present\120209\a1.txt',a,'(10(f12.0))');
unix('del ""'+projPath+'\a2.txt""');
write(projPath+'\a2.txt',a,'(10(f12.0))');

exit;