stacksize('max');

args = sciargs();
disp (args, 'sciargs = ');
if size(args) < 10 then
    imXPixel = strtod(args(4));
    lineFreq = strtod(args(5));
    bandWith = strtod(args(6));
    peakFreq = strtod(args(7));
    projPath = args(8);
    dataPath = args(9);
else
    imXPixel = strtod(args(5));
    lineFreq = strtod(args(6));
    bandWith = strtod(args(7));
    peakFreq = strtod(args(8));
    projPath = args(9);
    dataPath = args(10);
end

n = imXPixel/2;

//u = mopen(dataPath, 'r');
//foundFunct = mfscanf(n, u, '%f');
//frequency = mfscanf(n, u, '%f');
//mclose(u);

fd = mopen(dataPath, 'r');
for i = 1:n
    [m, frequency(i),foundFunct(i)] = mfscanf(fd, '%f\t%f');
end
file('close', fd);

//disp(foundFunct, 'foundFunct: ');
//disp(frequency, 'frequency: ');


// Notch-Filter

// filter order, bandstop
// hz=iir(1,'sb','butt',[.005 .01],[.08 .03]);
// fc = resonance in Hz / 156250
sampleFreq = 156250;
fc = peakFreq/sampleFreq; // X-Richtung S1110
//disp(fc, 'fc');
// fc=1160.76/156250/0.928;
Delta = (bandWith/sampleFreq)/2;
//disp(Delta, 'Delta');
//Delta = (DeltaMax - DeltaMin)*delay/sampleFreq;
//Delta=0.0015;
//Q = peakFreq/(Delta*sampleFreq);    // quality
//disp(Q, 'Q = ');
//hz=iir(2,'lp','ellip',[fc-3*Delta fc],[.08 .16]);
hz = iir(1,'sb','butt',[fc-Delta fc+Delta],[.08 .03]);

//scf(0); clf(0);
//bode(hz, 0.001, 0.5);
//[hzm,fr]=frmag(hz,256);
//plot2d(fr',hzm')
[frq,repf,splitf] = repfreq(hz,frequency./sampleFreq);
repfAbs = abs(repf);
//scf(1); //clf(1);
//plot(frq.*sampleFreq,repfAbs,'c');

u = file('open', projPath+'\repfreq.txt', 'unknown');
for i = 1:n
    fprintf(u, '%f', repfAbs(i));
end
file('close', u);

// filter
filteredFreq = ones(n);
for i = 1:n
    filteredFreq(i) = foundFunct(i)*repfAbs(i);
end

filteredFreq(1) = filteredFreq(2);
//scf(1); //clf(1);
//plot(frq.*sampleFreq,filteredFreq,'g');

// save x-axis, found not filtered function and found filtered function for Lazarus
//fprintfMat(yPunktePath, foundFunct(1:n), '%f', 'alte Funktion');
xAxis = ones (n,1);
for i = 1:n
    xAxis(i,1) = frq(i)*sampleFreq;
end

u = file('open', projPath+'\FunctPoints.txt', 'unknown');
for i = 1:n
    fprintf(u, '%f\t%f\t%f', xAxis(i),foundFunct(i),filteredFreq(i));
end
file('close', u);

//axes = gca();
//axes.log_flags = "nln";
//axes.children.children.thickness = 3;

q = poly(0,'q');     //to express the result in terms of the delay operator q=z^-1
hzd = horner(hz,1/q);

//    0.9845337 - 1.9671242q + 0.9845337q   
//    -----------------------------------   
//                                   2      
//        1 - 1.9671242q + 0.9690674q    

zaehler=coeff(hz(1,1).num);
nenner=coeff(hz(1,1).den);
shift=2**31;

a(1)=zaehler(1) * shift;
a(2)=zaehler(2) * shift /2 ;
a(3)=zaehler(3) * shift;
a(4)=-nenner(2)/2 * shift;
a(5)=-nenner(1)   * shift;
//disp(a(1) / 1000, 'a0=   / 1000');
//disp(a(2) / 1000, 'a1/2= / 1000');
//disp(a(3) / 1000, 'a2=   / 1000');
//disp(a(4) / 1000, 'b0/2  / 1000');
//disp(a(5) / 1000, 'b1    / 1000');


//unix('del ""C:\Program Files\Anfatec\bin\scanner\a2.txt""');
//write('C:\Program Files\Anfatec\bin\scanner\a2.txt',a,'(10(f12.0))');
unix('del ""'+projPath+'\a1.txt""');
write(projPath+'\a1.txt',a,'(10(f12.0))');

exit;